/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/************************ START OF SPECIFICATIONS ***************************/
/*                                                                          */
/* SOURCE FILE NAME:            DDCMD.H                                     */
/*                                                                          */
/* DESCRIPTIVE NAME: SSMDLL.C header file                                   */
/*                                                                          */
/*                                                                          */
/* STATUS:  OS/2 Release 2.0                                                */
/*                                                                          */
/* FUNCTION: This source module contains the defines and prototypes for the */
/*    SMMDLL.C module.                                                      */
/*                                                                          */
/* MODIFICATION HISTORY:                                                    */
/* DATE      DEVELOPER         CHANGE DESCRIPTION                           */
/* --------  -----------       --------------------                         */
/* 11/11/93  Brian Czako       Initial code added to module.                */
/*************************** END OF SPECIFICATIONS **************************/

/* Prototypes */

////////ULONG   DDCMDEntryPoint (PDDCMDCOMMON, ULONG);  // Defined in VSDAUD.H

ULONG   DDCmdSetup      (PDDCMDSETUP);
ULONG   DDCmdRead       (PDDCMDREADWRITE);
ULONG   DDCmdWrite      (PDDCMDREADWRITE);
ULONG   DDCmdStatus     (PDDCMDSTATUS);
ULONG   DDCmdControl    (PDDCMDCONTROL);
ULONG   DDCmdRegister   (PDDCMDREGISTER);
ULONG   DDCmdDeRegister (PDDCMDDEREGISTER);

#define DDSH_CATEGORY_INTERNAL  0x0080
#define DDCMD_PROCCNT_MTX "\\SEM32\\DDCMD"      /* SSM initialization semaphore */ /*FIX001*/

typedef struct  _DDSHPARMS
{
        PVOID  pBuffer;
        ULONG  rc;
} DDSHPARMS;

#define MAX_STREAM_NUM 64                       // max number of streams
typedef struct  _STREAM
{
        HFILE  hfileDDSHPDD;                    // handle to ring 0 stub WPOS
} STREAM;

typedef STREAM  *PSTREAM;
