/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/************************* START OCuF SPECIFICATIONIS ***
*
* SOURCE FILE NAME:  VSDFWD.C
*
* DESCRIPTIVE NAME: Ring 3 Amp/Mixer AUDIO Interface Driver
*
*
* STATUS:  OS/2 Release 2.0
*
* FUNCTION: This source module contains the ring 3 (DLL) entry point for
*           MCD Amp/Mixer calls from the Amp/Mixer or Waveform handler
*
* NOTES:
*        DEPENDENCIES: ACPA PDD
*        RESTRICTIONS: Runs in 32 bit protect mode (OS/2 2.0)
*
* ENTRY POINT:
*        AUDIOIFDriverEntry
*
* EXTERNAL REFERENCES: Sends IOCTL request to ACPA audio board
*
*/

#define INCL_NOPMAPI
#define INCL_DOS
#define INCL_ERRORS
#define INCL_RESOURCES

#include <os2.h>

/************************ START OF SPECIFICATIONS **************************
*
* SUBROUTINE NAME: AUDIOIFInit()
*
* FUNCTION: Initializes Audio Interface global data.
*
* INPUT:  None
*
* OUTPUT: Always returns 1 (required by assembler call).
*
* CALLED BY: AUDINIT.ASM (Initialization routine).
*
* OS/2 CALLS: DosCreateMutexSem()
*
*************************** END OF SPECIFICATIONS *************************/
#pragma linkage (_DLL_InitTerm, system)

ULONG APIENTRY _VSD_InitTerm (ULONG hModhandle, ULONG Flag);

ULONG _DLL_InitTerm (ULONG hModhandle, ULONG Flag)
{
   return (_VSD_InitTerm (hModhandle, Flag));
}

