.**************************************************************************
.*                            Lexmark Confidential
.*
.*  History
.*
.*  09/24/92 L. Cheatham     -  PD00769 : Added support for printer patterns
.*
.*  End History
.**************************************************************************
.*
.**********************************************
.*  PRINTER DRIVER - RELATED GLOSSARY TERMS
.*  FILE PRDgloss.IPF
.*  Edited:  FS/AK 19th July 1991
.**********************************************
.*
:h1 res=17307 hide.spool file
:p.A file containing output data that has been saved for later processing.

:h1 res=17188 hide.spooling
:p.The process of temporarily storing print jobs
while waiting for an available printer or
port at a print destination.  Spooling jobs frees system resources
from waiting for a relatively slow
device to provide output, and keeps
the contents of each print job separated
from the contents of every other print job.
.**********************************************************************
:h1 res=17177 hide.resolution
:p.Density or sharpness of an image.  For bit-map
material, resolution is expressed in dots-per-inch, with higher quality output
having more dots-per-inch.  You can adjust resolution for some
printers.  Low-resolution images are printed faster, but appear
coarser than high-resolution images.  A printer's
memory size might limit the resolution you can choose.
.**********************************************************************
:h1 res=17580 hide.device font
:p.A font particular to the printer.  Some
device fonts have size and language-support
restrictions.  Printer device fonts are
internal to the printer hardware, or they can be installed
as a card,
or downloaded to printer memory.  They are printed faster than
system fonts.
:p.
See also :link reftype=hd res=17193.system&rbl.font:elink.&per.
.**********************************************************************
:h1 res=17661 hide.download font
:p.
A :link reftype=hd res=17187.soft&rbl.font:elink. copied
(downloaded) to the memory of your printer.
.**********************************************************************
:h1 res=17169 hide.printer driver
:p.A file that
provides device-independence.  This file describes
the physical characteristics of a printer
and is used to convert graphics into device-specific data
at the time of printing.
.**********************************************************************
:h1 res=17242 hide.queue
:p.
A list of jobs waiting to be printed at a particular
print destination.
:p.See also :link reftype=hd res=17188.spooling:elink.&per.
.**********************************************************************
:h1 res=17193 hide.system font
:p.One of the general fonts
available for screen display and printing.  You
can specify any size for this font, and
it supports any language.  Contrast with
:link reftype=hd res=17580.device&rbl.font:elink.&per.
.**********************************************************************
:h1 res=17245 hide.radio button
:p.A circle with text beside it.  Radio buttons are combined to show you a
fixed set of choices from which only one can be selected.  The circle is
partially filled when a choice is selected.
.**********************************************************************
:h1 res=17062 hide.code page
:p.The character set used to display characters on the
screen or print characters on the printer.
.**********************************************************************
:h1 res=17187 hide.soft font
:p.Optional fonts shipped as files.  The soft-font files
must be copied to the hard
disk before you can select them from programs.
.**********************************************************************
:h1 res=17240 hide.push button
:p.A rectangle with text inside.  Push buttons are used in windows for actions
that occur immediately when the push button is selected.
.**********************************************************************
:h1 res=17110 hide.font
:p.A given size and style of type.  A family
of characters of a given size and style; for example, 9-point
Helvetica.
.**********************************************************************
:h1 res=17034 hide.default
:p.A value, an attribute, or an option that is assumed
when another is not explicitly specified.
.**********************************************************************
:h1 res=17202 hide.path
:p.A statement that indicates where a file is stored.  The path
consists of the drive letter and all the directories
that must be opened to get to a particular file.
The directory names are separated by a backslash (&bslash.).
The first backslash represents the root directory.  The first path in the example
below shows a file that is located in the root directory of a diskette
in drive A; the second path in the example shows a path to a printer driver file on drive C&colon.
:xmp.
 A&colon.&bsl.
 C&colon.&bsl.OS2&bsl.DLL&bsl.DDK42XX
:exmp.
:p.A path is sometimes followed by a file name and file-name extension (if there is one).
.************************************************************************
.* LEXMARK 6 add :h1 entry for check mark     PD00769
.************************************************************************
:h1 res=17204 hide.check mark
:p.A symbol that shows that a choice is currently active.  This symbol is used
in menus and check boxes.  See
:link reftype=hd res=17205.check&rbl.box:elink.&per.

.************************************************************************
.* LEXMARK 6 add :h1 entry for check box      PD00769
.************************************************************************
:h1 res=17205 hide.check box
:p.A square box with associated text that represents one choice in a set of
multiple choices.  When you select a choice, a
:link reftype=hd res=17204.check&rbl.mark:elink.
appears in the check box to indicate that the choice is in effect.  You can
clear the check box by selecting the choice again.  Contrast with
:link reftype=hd res=17245.radio&rbl.button:elink.&per.
